/**
 * Created by hh on 16/1/30.
 */

/*使用:
1.初始化:
  在app.js中的app.run方法中加入Jcob.initCache("userInfoCache","jcob_userInfo");
  初始化Jcob.userInfoCache对象,该对象用于操作localStorage中名为"Jcob_userInfo"的缓存对象
2.使用:
  save(key,value)
  load(key)
  loadAll()
  remove(key)
  clear()
3.关于用户登录信息(翔鹏需要)新增了Jcob.loginCache对象,使用方法:
  save(phone,imageUrl)
  save(obj),obj中包含obj.phone和obj.imageUrl
  loadImage(phone)
  loadRecentData()获取最近登陆的信息
  clear()*/

var myConfig = {
    'itunesUrl':'http://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?id=956458683&pageNumber=0&sortOrdering=2&type=Purple+Software&mt=8',
};

var Jcob = function () {
    //目前在app.js中的run中初始化
    //key为cache的名称
    //userInfoCache,loginDataCache
    var initCache = function (cacheName,keyString) {
        var cache = function () {
            var cacheKey = keyString;
            var conn = {};
            var cacheData ;
            conn.save = function (key, value) {
                cacheData = JSON.parse(localStorage.getItem(cacheKey))||{};
                cacheData[key] = value;
                localStorage.setItem(cacheKey, JSON.stringify(cacheData));
                return cacheData;
            };
            conn.isKeyExist = function(key){
                cacheData = JSON.parse(localStorage.getItem(cacheKey))||{};
                var bln = false;
                for(var k in cacheData){
                    if(k == key){
                        bln = true;
                    }
                }
                return bln;
            };
            conn.load = function (key) {
                try {
                    cacheData = JSON.parse(localStorage.getItem(cacheKey));
                    if (typeof(cacheData[key]) == "undefined") {
                        return null;
                    }
                    return cacheData[key];
                } catch (e) {
                    return false;
                }
            };
            conn.loadAll = function () {
                try {
                    cacheData = JSON.parse(localStorage.getItem(cacheKey));
                    if (typeof(cacheData) == "undefined") {
                        return null;
                    }
                    return cacheData;
                } catch (e) {
                    return false;
                }
            };
            conn.remove = function (key) {
                try {
                    cacheData = JSON.parse(localStorage.getItem(cacheKey));
                    delete cacheData[key];
                    localStorage.setItem(cacheKey,JSON.stringify(cacheData));
                    return true;
                } catch (e) {
                    return false;
                }
            };
            conn.clear = function () {
                cacheData = {};
                localStorage.setItem(cacheKey, JSON.stringify(cacheData));
            };
            return conn;
        }();
        jcob[cacheName] = cache;
        return jcob[cacheName];
    };
    //login相关
    var loginCache = function(){
        var loginDataArray = [];
        var loginCacheDataLength = 5;
        var loginCacheKey = "jcob_loginData";
        var conn = {};
        conn.saveLoginObj = function(loginObj){
            try{
                var phone = loginObj.phone;
                var imageUrl = loginObj.imageUrl;
                return conn.save(phone,imageUrl);
            }catch(e){
                return false;
            }
        };
        conn.save = function(phone,imageUrl){
            if(conn.isPhoneExist(phone)){
                var newDataArray = [];
                for(var i = 0;i<loginDataArray.length;i++){
                    if (loginDataArray[i].phone == phone) {
                        loginDataArray[i].imageUrl = imageUrl;
                        newDataArray.unshift(loginDataArray[i]);
                    }else{
                        newDataArray.push(loginDataArray[i]);
                    }
                }
                loginDataArray = newDataArray;
            }else{
                if(loginDataArray.unshift({phone:phone,imageUrl:imageUrl})>loginCacheDataLength){
                    loginDataArray.pop();
                }
            }
            localStorage.setItem(loginCacheKey,JSON.stringify(loginDataArray));
            return loginDataArray;
        };
        conn.isPhoneExist = function(phone){
            loginDataArray = JSON.parse(localStorage.getItem(loginCacheKey))||[];
            var bln = false;
            try {
                for (var i = 0; i < loginDataArray.length; i++) {
                    if (loginDataArray[i].phone == phone) {
                        bln = true;
                    }
                }
                return bln;
            } catch (e) {
                return bln;
            }
        };
        conn.loadImage = function(phone){
            if(conn.isPhoneExist(phone)){
                for(var i = 0;i<loginDataArray.length;i++){
                    if (loginDataArray[i].phone == phone) {
                        return loginDataArray[i].imageUrl;
                    }
                }
            }else{
                return false;
            }
        };
        conn.loadRecentData = function(){
            if(!localStorage.getItem(loginCacheKey)){
                return false;
            }else{
                return JSON.parse(localStorage.getItem(loginCacheKey));
            }
        };
        conn.clear = function(){
            return localStorage.removeItem(loginCacheKey);
        };
        return conn;
    }();

    var jcob = {};
    var followIdSet = {1:{},2:{}};//1足球，2篮球
    jcob.toDecimal2 = function(x) {
        var f = parseFloat(x);
        if (isNaN(f)) {
            return false;
        }
        var f = Math.round(x*100)/100;
        var s = f.toString();
        var rs = s.indexOf('.');
        if (rs < 0) {
            rs = s.length;
            s += '.';
        }
        while (s.length <= rs + 2) {
            s += '0';
        }
        return s;
    };
    jcob.addFollowId = function(id,type){
      followIdSet[type][id] = true;
      localStorage.setItem("newFollowMatch",1);
    };
    jcob.removeFollowId = function(id,type){
      followIdSet[type][id] = false;
      localStorage.setItem("newFollowMatch",1);
    };
    jcob.clearFollowIdSet = function(){
      followIdSet={1:{},2:{}};
    };
    jcob.hasFollowId = function(id,type){
      return !!followIdSet[type][id]
    };
    jcob.loginCache = loginCache;
    jcob.initCache = initCache;
    return jcob;
}();
