var userValidate =  {
        SUCREG: "success",
        FALREG: "failure",
        memValidateRes: {
            "S": {
                result: "success"
            },
            "F": {
                result: "failure",
                code: ""
            }
        },
        memberValidateErr: {
            "EMPTY": "EMPTY",
            "RANGE": "RANGE",
            "INVALIDCHAR": "INVALIDCHAR",
            "NOCHINESE": "NOCHINESE",
            "NOMOBILE": "NOMOBILE",
            "NOTEL": "NOTEL",
            "NOCONCAT": "NOCONCAT",
            "PASSWD": "PASSWD",
            "NOSEC": "NOSEC",
            "NOMAIL": "NOMAIL",
            "NOCHKCODE": "NOCHKCODE",
            "NODIGIT": "NODIGIT",
            "IDCARDLEN": "IDCARDLEN",
            "WEAKPWD": "WEAKPWD",
            "FORMATERR": "FORMATERR"
        },
        pwdValResult: {
            'S': { result: 'success' },
            'F': { result: 'failure', code: '' }
        },
        pwdValErr: {
            'NotBase': 'NotBase',
            'NotEmpty': 'NotEmpty',
            'AccountSamePwd': 'AccountSamePwd',
            'Exsited': 'Exsited',
            'NotSame': 'NotSame',
            'LengthErr': 'LengthErr',
            'NotRepeat': 'NotRepeat',
            'NotOrderStr': 'NotOrderStr'
        },
        pwdValidate: function (pwd, account) {
          //  pwd = pwd.replace(/\s/g, "");
         //   account = account.replace(/\s/g, "");
            if (pwd === '' || pwd === null || typeof pwd === 'undefined') {
                userValidate.pwdValResult.F.code = userValidate.pwdValErr.NotEmpty;
                return userValidate.pwdValResult.F;
            }
            if (pwd == account) {
                userValidate.pwdValResult.F.code = userValidate.pwdValErr.AccountSamePwd;
                return userValidate.pwdValResult.F;
            }
            if (pwd.length < 6 || pwd.length > 15) {
                userValidate.pwdValResult.F.code = userValidate.pwdValErr.LengthErr;
                return userValidate.pwdValResult.F;
            }
            var baseExp = /^[0-9A-Za-z]{6,15}$/;
            if (!baseExp.test(pwd)) {
                userValidate.pwdValResult.F.code = userValidate.pwdValErr.NotBase;
                return userValidate.pwdValResult.F;
            }
            var p1 = /[0-9]/; var b1 = p1.test(pwd);
            var p2 = /[a-zA-Z]/i; var b2 = p2.test(pwd);
            if(b1==false || b2==false){
              userValidate.pwdValResult.F.code = userValidate.pwdValErr.NotBase;
              return userValidate.pwdValResult.F;
            }
            var pwdArr = new Array('112233', '123123', '123321', 'abcabc', 'abc123', 'a1b2c3', 'aaa111', '123qwe', 'qweasd', 'admin', 'password', 'passwd', 'iloveyou', '5201314', 'adobe123', 'letmein', 'photoshop', 'monkey', 'shadow', 'sunshine', 'password1', 'princess', 'azerty', 'trustno1');
            for (var i = 0; i < pwdArr.length; i++) {
                if (pwdArr[i] == pwd) {
                    userValidate.pwdValResult.F.code = userValidate.pwdValErr.Exsited;
                    return userValidate.pwdValResult.F;
                }
            }
            var ascStr = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
            var descStr = "zyxwvutsrqponmlkjihgfedcbaZYXWVUTSRQPONMLKJIHGFEDCBA9876543210";
            if ((ascStr.indexOf(pwd) > -1) || (descStr.indexOf(pwd) > -1)) {
                userValidate.pwdValResult.F.code = userValidate.pwdValErr.NotOrderStr;
                return userValidate.pwdValResult.F;
            }
            var repeatExp = new RegExp(pwd.substring(0, 1) + '{' + pwd.length + '}');
            if (repeatExp.test(pwd)) {
                userValidate.pwdValResult.F.code = userValidate.pwdValErr.NotRepeat;
                return userValidate.pwdValResult.F;
            }
            return userValidate.pwdValResult.S;
        },
        memValidate: {
            accountNumber: function (input) {
                var type = '/\d{5}/';
                var reg = new RegExp(type);
                if (reg.test(input)) {
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            accountCheck: function (input, minLen, maxLen) {
                var re1 = new RegExp("^[a-zA-Z0-9\u4e00-\u9fa5]+$");
                if (!re1.test(input)) {
                    return userValidate.memValidateRes.F;
                }
                return this.accountLength(input, minLen, maxLen);
            },
            //验证昵称
            accountLength: function (input, minLen, maxLen) {
                var sum = 0;
                for (var i = 0, len = input.length; i < len; i++) {
                    if ((0 <= input.charCodeAt(i)) && (input.charCodeAt(i) <= 255)) {
                        sum++;
                    }
                    else {
                        sum += 2;
                    }
                }
                if (sum < minLen || sum > maxLen) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.RANGE;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            checkSpechar: function (input, msg) {
                var SPECIAL_STR = "#~!@%^&*();'\"?><[]{}\\|,:/=-+—“”‘.`$";
                for (var i = 0; i < input.length; i++) {
                    if (SPECIAL_STR.indexOf(input.charAt(i)) != -1 || input.charAt(i) == "") {
                        userValidate.memValidateRes.F.code = userValidate.memberValidateErr.INVALIDCHAR;
                        return userValidate.memValidateRes.F;
                    }
                }
                if (!/^[0-9a-zA-Z\u4E00-\u9FA5]{2,14}$/.test(input)) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.INVALIDCHAR;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            isPasswd: function (pwd, minlen, maxlen) {
                var passwd_regstr = new RegExp("^([a-zA-Z0-9]){" + minlen + "," + maxlen + "}$");
                if (!passwd_regstr.test(pwd)) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.PASSWD;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            checkPasswdSec: function (account, passwd) {
                if (account == passwd) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.NOSEC;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            checkChinese: function (input) {
                if (input == "") {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.EMPTY;
                    return userValidate.memValidateRes.F;
                }
                var xj = ['·', '●', '.', '-'];
                var isXj = false;
                for (var i = 0; i < xj.length; i++) {
                    if (input.indexOf(xj[i]) != -1) {
                        isXj = true;
                        var arr = input.split(xj[i]);
                        if (arr.length > 2) {
                            userValidate.memValidateRes.F.code = userValidate.memberValidateErr.INVALIDCHAR;
                            return userValidate.memValidateRes.F;
                        }
                        if (!arr[0].match(/^[\u4E00-\uFA29\uE7C7-\uE7F3]/) || !arr[1].match(/^[\u4E00-\uFA29\uE7C7-\uE7F3]/)) {
                            userValidate.memValidateRes.F.code = userValidate.memberValidateErr.INVALIDCHAR;
                            return userValidate.memValidateRes.F;
                        }
                        if (arr[0].length < 2 || arr[0].length > 10 || arr[1].length < 2 || arr[1].length > 9) {
                            userValidate.memValidateRes.F.code = userValidate.memberValidateErr.FORMATERR;
                            return userValidate.memValidateRes.F;
                        }
                    }
                }
                if (!isXj) {
                    if (!input.match(/^[\u4E00-\uFA29\uE7C7-\uE7F3]/)) {
                        userValidate.memValidateRes.F.code = userValidate.memberValidateErr.INVALIDCHAR;
                        return userValidate.memValidateRes.F;
                    }
                }
                var reg1 = new RegExp("^[\u4E00-\uFA29\uE7C7-\uE7F3]{2,10}$");
                var reg2 = new RegExp("^[\u4E00-\uFA29\uE7C7-\uE7F3]{2,10}[·][\u4E00-\uFA29\uE7C7-\uE7F3]{2,9}$");
                var reg3 = new RegExp("^[\u4E00-\uFA29\uE7C7-\uE7F3]{2,10}[●][\u4E00-\uFA29\uE7C7-\uE7F3]{2,9}$");
                var reg4 = new RegExp("^[\u4E00-\uFA29\uE7C7-\uE7F3]{2,10}[.][\u4E00-\uFA29\uE7C7-\uE7F3]{2,9}$");
                var reg5 = new RegExp("^[\u4E00-\uFA29\uE7C7-\uE7F3]{2,10}[\\-][\u4E00-\uFA29\uE7C7-\uE7F3]{2,9}$");
                if (!(reg1.test(input)) && !(reg2.test(input)) && !(reg3.test(input)) && !(reg4.test(input)) && !(reg5.test(input))) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.NOCHINESE;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            isIDCard: function (input) {
                if (input == "") {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.EMPTY;
                    return userValidate.memValidateRes.F;
                }
                var reg = /^\d{1,}[xX]?$/;
                if (!reg.test(input)) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.NODIGIT;
                    return userValidate.memValidateRes.F;
                }
                if (input.length != 15 && input.length != 18) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.IDCARDLEN;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            isMobile: function (mobile) {
                var mobile_reg = /^(1)\d{10}$/;
                if (!mobile_reg.test(mobile)) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.NOMOBILE;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            isTel: function (tel, msg) {
                var tel_reg = /^(([0\+]\d{2,3}-)?(0\d{2,3})-)(\d{7,8})(-(\d{3,}))?$/;
                if (!tel_reg.test(tel)) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.NOTEL;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            //验证联系方式，包括电话和手机[座机的分机号最大是7位]
            isContact: function (contact) {
                var mobile_reg = /^(1)\d{10}$/;
                var tel_reg = /^(([0\+]\d{2,3}-)?(0\d{2,3})-)(\d{7,8})(-(\d{3,7}))?$/;
                var isMobile = mobile_reg.test(contact);
                var isTel = tel_reg.test(contact);
                if (!isMobile && !isTel) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.NOCONCAT;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            isMail: function (mail) {
                var mail_reg = /^([0-9a-zA-Z]([-.\w]*[0-9a-zA-Z])*@([0-9a-zA-Z][-\w]*[0-9a-zA-Z]\.)+[a-zA-Z]{2,9})$/;
                if (!mail_reg.test(mail)) {
                    userValidate.memValidateRes.F.code = userValidate.memberValidateErr.NOMAIL;
                    return userValidate.memValidateRes.F;
                }
                return userValidate.memValidateRes.S;
            },
            validCodeLength: function (code) {
                // if (jQuery.trim(code) == "") {
                //     userValidate.memValidateRes.F.code = userValidate.memberValidateErr.NOCHKCODE;
                //     return userValidate.memValidateRes.F;
                // }
                // return userValidate.memValidateRes.S;
            },
            passwdStrength: function (pwd) {
                var Modes = 0;
                for (var i = 0; i < pwd.length; i++) {
                    Modes |= this.CharMode(pwd.charCodeAt(i));
                }
                return this.bitTotal(Modes);
            },
            CharMode: function (iN) {
                if (iN >= 48 && iN <= 57)
                    return 1;
                if (iN >= 65 && iN <= 90)
                    return 2;
                if (iN >= 97 && iN <= 122)
                    return 4;
                else
                    return 8; //特殊字符
            },
            bitTotal: function (num) {
                var modes = 0;
                for (var i = 0; i < 4; i++) {
                    if (num & 1)
                        modes++;
                    num >>>= 1;
                }
                return modes;
            }
        }
    };
