cordova.define("cordova.plugin.AicaiClient.AicaiClient", function(require, exports, module) {
var exec = require('cordova/exec'),
    cordova = require('cordova'),
    channel = require('cordova/channel'),
    utils = require('cordova/utils');

//channel.createSticky('onCordovaXGPushReady');
//channel.waitForInitialization('onCordovaXGPushReady');

//exports.loginSuccess = function(key, success, error) {
//    exec(success, error, "JcobClient", "loginSuccess", [{test:"test!"}]);
//};
function AicaiClient() {
    var me = this;
    this.channels = {
        'viewChange': channel.create('viewChange'),
        'loginSuccess': channel.create('loginSuccess'),
        'identitySuccess': channel.create('identitySuccess')
    };
    this.on = function (type, func) {
        if (type in me.channels) {
            me.channels[type].subscribe(func);
        }
    };
    this.init = function(data){
        channel.onCordovaReady.subscribe(function () {
            exec(function(event){
                if (event && (event.type in me.channels)) {
                    me.channels[event.type].fire(event);
                }
            },null, "AicaiClient", "addListener", [data]);
        });
    };

    this.exitApp = function(data,success){
        exec(success, null, "AicaiClient", "exitApp", [data]);
    };
    this.hideApp = function(data,success){
        exec(success, null, "AicaiClient", "hideApp", [data]);
    };
    this.viewChange = function(data,success){
        exec(success, null, "AicaiClient", "viewChange", [data]);
    };
    this.loginListener = function(data,success){
        exec(success, null, "AicaiClient", "loginListener", [data]);
    };
    this.openBrowser = function (data,success) {
        exec(success, null, "AicaiClient", "openBrowser", [data]);
    };
    this.openSystemBrowser = function (data,success) {
        exec(success, null, "AicaiClient", "openSystemBrowser", [data]);
    };
    this.copyToPasteBoard = function (url,success) {
        exec(success, null, "AicaiClient", "copyToPasteBoard", [{copyInfo:url}]);
    };
    this.rsaEncodedString = function(uuid, success, error) {
        exec(success, error, "AicaiClient", "rsaEncodedString", [{udid:uuid}]);
    };
    this.getIdfa = function(success,error){
        exec(success, error, "AicaiClient", "getIdfa");
    };
    this.getTrackId = function(pkgName,success,error){
        exec(success,error,"AicaiClient","getTrackId", [{pkgName:pkgName}]);
    };
}
module.exports = new AicaiClient();

});
